> For the complete documentation index, see [llms.txt](https://docs.neuron-ai.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.neuron-ai.dev/v2/rag.md).

# RAG

- [Getting Started](https://docs.neuron-ai.dev/v2/rag/rag.md): Step by Step guide on how to implement Retrieval-Augmented Generation with Neuron framework.
- [Data loader](https://docs.neuron-ai.dev/v2/rag/data-loader.md): Learn how to create data loader pipelines to feed your RAG applications.
- [Embeddings Provider](https://docs.neuron-ai.dev/v2/rag/embeddings-provider.md): Integrate services to transform text into vectors for semantic search.
- [Vector Store](https://docs.neuron-ai.dev/v2/rag/vector-store.md): Neuron provides you with ready to use components to connect your agent to vector databases.
- [Pre/Post Processor](https://docs.neuron-ai.dev/v2/rag/pre-post-processor.md): Improve the RAG output by pre/post processing prompts and retrieval results.
- [Retrieval](https://docs.neuron-ai.dev/v2/rag/retrieval.md): Implement custom retrieval strategies


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.neuron-ai.dev/v2/rag.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
